Bug 507954 - yum-updatesd generates incorrect syslog entries (ignores syslog ident)
yum-updatesd generates incorrect syslog entries (ignores syslog ident)
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: yum-updatesd (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: James Antill
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-24 16:12 EDT by Carl Roth
Modified: 2009-12-18 04:35 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 04:35:11 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Carl Roth 2009-06-24 16:12:19 EDT
Description of problem:

yum-updatesd, when configured to generate syslog entries, does not generate the entries with the configured (or default) syslog identifier.  In all cases, the syslog identifier is null.

For example:

Jun 24 12:57:06 huggy : 8 updates available

It should rather be:

Jun 24 12:57:06 huggy yum-updatesd: 8 updates available

Version-Release number of selected component (if applicable):

yum-updatesd-0.9-1.fc9.noarch

Here is the command-line I used to test the settings:

# /usr/libexec/yum-updatesd-helper --syslog --syslog-level=WARN --syslog-facility=DAEMON --syslog-ident=yum-updatesd --debug --check

And here is my yum-updatesd.conf file:

[main]
# how often to check for new updates (in seconds)
run_interval = 10800
# how often to allow checking on request (in seconds)
updaterefresh = 600

# how to send notifications (valid: dbus, email, syslog)
emit_via = syslog
# should we listen via dbus to give out update information/check for
# new updates 
dbus_listener = no

# automatically install updates
do_update = no
# automatically download updates
do_download = no
# automatically download deps of updates
do_download_deps = no

How reproducible:

always

Steps to Reproduce:
1. configure /etc/yum/yum-updatesd.conf to generate syslog notifications
2. run yum-updatesd on a system that requires updates
3.
  
Actual results:


Expected results:


Additional info:

From what I can tell, yum-updatesd is stumbling over the the YUM library, which re-initializes the syslog facility (see YumBase.doConfigSetup).  Unless there is a syslog configuration in yum.conf, it gets reset to use a null syslog ident.

There are a variety of fixes, but the one I came up with (please forgive me) is to re-initialize syslog immediately after the YUM library is initialized.  Feel free to suggest a cleaner solution.  See my patch:

diff -u /usr/libexec/yum-updatesd-helper /tmp/yum-updatesd-helper 
--- /usr/libexec/yum-updatesd-helper	2007-12-17 20:19:44.000000000 -0800
+++ /tmp/yum-updatesd-helper	2009-06-24 13:01:17.421686194 -0700
@@ -347,17 +347,30 @@
                                                     self.options.smtpserver,
                                                     self.options.sendmail))
         if self.options.syslog:
-            self.emitters.append(SyslogUpdateEmitter(self.options.logfacility,
-                                                     self.options.logident,
-                                                     self.options.loglevel))
+            self.syslog_emitter = SyslogUpdateEmitter(self.options.logfacility,
+                                                      self.options.logident,
+                                                      self.options.loglevel)
+            self.emitters.append(self.syslog_emitter)
         if self.options.debug:
             self.emitters.append(StderrUpdateEmitter())
         self.updateInfo = []
 
+    def doSetupSyslog(self):
+        """Initialize or re-initialize the syslog facility.
+
+        Note that the YUM library re-initializes syslog.
+        """
+        if self.options.syslog:
+            syslog.openlog(self.options.logident,
+                           0,
+                           self.syslog_emitter._facilityMap(self.options.logfacility))
+        
     def doSetup(self):
         try:
             self.doConfigSetup(fn=self.options.config)
+            self.doSetupSyslog()
         except Exception, e:
+            self.doSetupSyslog()
             syslog.syslog(syslog.LOG_WARNING,
                           "error initializing: %s" % e)
Comment 1 Bug Zapper 2009-11-18 07:07:31 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2009-12-18 04:35:11 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.